INCLUDE SSEcode.inc

.code

SSEcode2 PROC
    push rax
    push rbx
    push rcx
    push rdx
    push rdi
    push rsi
    align 16
    mov     rbx, d2a
    mov     rcx, 0                  ; k
    mov     rdx, j2a
    add     rdx, rdx                ; j*2
    mov     rdi, na
    add     rdi, rdi                ; n*2
    mov     rsi, aDataSP            ; not lea
    add     rsi, rdx                ; address cDataSP[j2]
    mov     rdx, rbx                ; d2
    add     rdx, rdx                ; d2*2
    mov     rax, rsi                ; address cDataSP[j2]
    add     rax, rcx                ; address cDataSP[jk or j2 + k]
    mov     rsi, cExpSPA
    movaps  xmm2, [rsi]             ; ExpImag1SP, - ExpImag1SP
    movaps  xmm3, [rsi+16]          ; ExpReal1SP,   ExpReal1SP
    align 16
lp: movaps  xmm0, [rax+rbx]         ; cDataSP[j2+k+d2] & [j2+k+d2+1] & [j2+k+d2+2] & [j2+k+d2+3]
    movaps  xmm1, xmm0              ; cDataSP[j2+k+d2] & [j2+k+d2+1] & [j2+k+d2+2] & [j2+k+d2+3]
    mulps   xmm0, xmm2              ; cDataSP[pair] * ExpImag1SP, -ExpImag1SP
    shufps  xmm0, xmm0, 177         ; reverse 2 pairs
    mulps   xmm1, xmm3              ; cDataSP[quad] * ExpReal1SP, ExpReal1SP
    addps   xmm1, xmm0              ; tempReal1, tempImag1, tempReal2, tempImag2
    movaps  xmm4, [rax]             ; cDataSP[j2+k] & [j2+k+1] & [j2+k+2] & [j2+k+3]
    movaps  xmm5, xmm4              ; cDataSP[j2+k] & [j2+k+1] & [j2+k+2] & [j2+k+3]
    subps   xmm4, xmm1              ; cDataSP[pair] - tempReal, tempImag 
    movaps  [rax+rbx], xmm4         ; save cDataSP[j2+k+d2] & [j2+k+d2+1] & [j2+k+d2+2] & [j2+k+d2+3]
    addps   xmm5, xmm1              ; cDataSP[quad] + tempReal, tempImag
    movaps  [rax], xmm5             ; save cDataSP[j2+k] & cDataSP[j2+k+1]  & [j2+k+2] & [j2+k+3]
    add     rax, rdx                ; address cDataSP[j2+k+d2]
    add     rcx, rdx                ; k=k+d2
    cmp     rcx, rdi                ; k vs b2
    jl      lp
    pop rsi
    pop rdi
    pop rdx
    pop rcx
    pop rbx
    pop rax
    ret
SSEcode2 ENDP

SSEcode4 PROC
    push rax
    push rbx
    push rcx
    push rdx
    push rdi
    push rsi
    align 16
    mov  eax, DWORD PTR xmmSave
    movapd  OWORD PTR [eax], xmm6
    movapd  OWORD PTR [eax+16], xmm7
    mov     rbx, d2a
    mov     rcx, 0                  ; k
    mov     rdx, j2a
    add     rdx, rdx                ; j*2
    mov     rdi, na
    add     rdi, rdi                ; n*2
    mov     rsi, aDataSP            ; not lea
    add     rsi, rdx                ; address cDataSP[j2]
    mov     rdx, rbx                ; d2
    add     rdx, rdx                ; d2*2
    mov     rax, rsi                ; address cDataSP[j2]
    add     rax, rcx                ; address cDataSP[jk or j2 + k]
    mov     rsi, cExpSPA
    movaps  xmm4, [rsi]             ; ExpImag1SP, - ExpImag1SP, ExpImag2SP, - ExpImag2SP
    movaps  xmm5, [rsi+16]          ; ExpImag3SP, - ExpImag3SP, ExpImag4SP, - ExpImag4SP
    movaps  xmm6, [rsi+32]          ; ExpReal1SP,   ExpReal1SP, ExpReal2SP,   ExpReal2SP
    movaps  xmm7, [rsi+48]          ; ExpReal3SP,   ExpReal3SP, ExpReal4SP,   ExpReal4SP
    align 16
lp: movaps  xmm0, [rax+rbx]         ; cDataSP[j2+k+d2]   & [j2+k+d2+1] & [j2+k+d2+2] & [j2+k+d2+3]
    movaps  xmm1, [rax+rbx+16]      ; cDataSP[j2+k+d2+4] & [j2+k+d2+5] & [j2+k+d2+6] & [j2+k+d2+7]
    movaps  xmm2, xmm0              ; cDataSP[j2+k+d2]   & [j2+k+d2+1] & [j2+k+d2+2] & [j2+k+d2+3]
    movaps  xmm3, xmm1              ; cDataSP[j2+k+d2+2] & [j2+k+d2+3] & [j2+k+d2+6] & [j2+k+d2+7]
    mulps   xmm0, xmm4              ; cDataSP[1] * ExpImag1SP, - ExpImag1SP, ExpImag2SP, - ExpImag2SP
    mulps   xmm1, xmm5              ; cDataSP[2] * ExpImag3SP, - ExpImag3SP, ExpImag4SP, - ExpImag4SP
    shufps  xmm0, xmm0, 177         ; reverse 2 pairs
    shufps  xmm1, xmm1, 177         ; reverse 2 pairs
    mulps   xmm2, xmm6              ; cDataSP[1] * ExpReal1SP, ExpReal1SP, ExpReal2SP, ExpReal2SP
    mulps   xmm3, xmm7              ; cDataSP[2] * ExpReal3SP, ExpReal3SP, ExpReal4SP, ExpReal4SP
    addps   xmm0, xmm2              ; tempReal1, tempImag1, tempReal2, tempImag2
    addps   xmm1, xmm3              ; tempReal3, tempImag3, tempReal4, tempImag4
    movaps  xmm2, [rax]             ; cDataSP[j2+k]   & [j2+k+1] & [j2+k+2] & [j2+k+3]
    movaps  xmm3, [rax+16]          ; cDataSP[j2+k+4] & [j2+k+5] & [j2+k+6] & [j2+k+7]
    subps   xmm2, xmm0              ; cDataSP[quad] - tempReal1, tempImag1, tempReal2, tempImag2
    subps   xmm3, xmm1              ; cDataSP[quad] - tempReal3, tempImag3, tempReal4, tempImag4
    movaps  [rax+rbx],    xmm2      ; save cDataSP[j2+k+d2]   & [j2+k+d2+1] & [j2+k+d2+2] & [j2+k+d2+3]
    movaps  [rax+rbx+16], xmm3      ; save cDataSP[j2+k+d2+4] & [j2+k+d2+5] & [j2+k+d2+6] & [j2+k+d2+7]
    movaps  xmm2, [rax]             ; cDataSP[j2+k]   & [j2+k+1] & [j2+k+2] & [j2+k+3]
    movaps  xmm3, [rax+16]          ; cDataSP[j2+k+4] & [j2+k+5] & [j2+k+6] & [j2+k+7]
    addps   xmm2, xmm0              ; cDataSP[quad] + tempReal1, tempImag1, tempReal2, tempImag2
    addps   xmm3, xmm1              ; cDataSP[quad] + tempReal3, tempImag3, tempReal4, tempImag4
    movaps  [rax],    xmm2          ; save cDataSP[j2+k]   & [j2+k+1] & [j2+k+2] & [j2+k+3]
    movaps  [rax+16], xmm3          ; save cDataSP[j2+k+4] & [j2+k+5] & [j2+k+6] & [j2+k+7]
    add     rax, rdx                ; address cDataSP[j2+k+d2]
    add     rcx, rdx                ; k=k+d2
    cmp     rcx, rdi                ; k vs b2
    jl      lp
    mov  eax, DWORD PTR xmmSave
    movapd  xmm6, OWORD PTR [eax]
    movapd  xmm7, OWORD PTR [eax+16]
    pop rsi
    pop rdi
    pop rdx
    pop rcx
    pop rbx
    pop rax
    ret
SSEcode4 ENDP
 

SSE2code1 PROC
    push rax
    push rbx
    push rcx
    push rdx
    push rdi
    push rsi
    align 16
    mov     rbx, d2a
    mov     rcx, 0                  ; k
    mov     rdx, j2a
    add     rdx, rdx                ; j*2
    mov     rdi, na
    add     rdi, rdi                ; n*2
    mov     rsi, aDataDP            ; not lea
    add     rsi, rdx                ; address cDataDP[j2]
    mov     rdx, rbx                ; d2
    add     rdx, rdx                ; d2*2
    mov     rax, rsi                ; address cDataDP[j2]
    add     rax, rcx                ; address cDataDP[jk or j2 + k]
    mov     rsi, cExpDPA
    movapd  xmm2, [rsi]             ; ExpImag1DP, - ExpImag1DP
    movapd  xmm3, [rsi+16]          ; ExpReal1DP,   ExpReal1DP
    align 16
lp: movapd  xmm4, [rax]             ; cDataDP[j2+k] & cDataDP[j2+k+1]
    movapd  xmm0, [rax+rbx]         ; cDataDP[j2+k+d2] & [j2+k+d2+1]
    movapd  xmm5, xmm4              ; cDataDP[j2+k] & cDataDP[j2+k+1]
    movapd  xmm1, xmm0              ; cDataDP[j2+k+d2] & [j2+k+d2+1]
    mulpd   xmm0, xmm2              ; cDataDP[pair] * ExpImag1DP, -ExpImag1DP
    shufpd  xmm0, xmm0, 1           ; reverse pair
    mulpd   xmm1, xmm3              ; cDataDP[pair] * ExpReal1DP, ExpReal1DP
    addpd   xmm1, xmm0              ; tempReal, tempImag
    subpd   xmm4, xmm1              ; cDataDP[pair] - tempReal, tempImag 
    addpd   xmm5, xmm1              ; cDataDP[pair] + tempReal, tempImag
    movapd  [rax], xmm5             ; save cDataDP[j2+k] & cDataDP[j2+k+1]
    movapd  [rax+rbx], xmm4         ; save cDataDP[j2+k+d2] & [j2+k+d2+1]
    add     rax, rdx                ; address cDataDP[j2+k+d2]
    add     rcx, rdx                ; k=k+d2
    cmp     rcx, rdi                ; k vs b2
    jl      lp
    pop rsi
    pop rdi
    pop rdx
    pop rcx
    pop rbx
    pop rax
    ret
SSE2code1 ENDP

 
SSE2code2 PROC
    push rax
    push rbx
    push rcx
    push rdx
    push rdi
    push rsi
    align 16
    mov  eax, DWORD PTR xmmSave
    movapd  OWORD PTR [eax], xmm6
    movapd  OWORD PTR [eax+16], xmm7
    mov     rbx, d2a
    mov     rcx, 0                  ; k
    mov     rdx, j2a
    add     rdx, rdx                ; j*2
    mov     rdi, na
    add     rdi, rdi                ; n*2
    mov     rsi, aDataDP            ; not lea
    add     rsi, rdx                ; address cDataDP[j2]
    mov     rdx, rbx                ; d2
    add     rdx, rdx                ; d2*2
    mov     rax, rsi                ; address cDataDP[j2]
    add     rax, rcx                ; address cDataDP[jk or j2 + k]
    mov     rsi, cExpDPA
    movapd  xmm4, [rsi]             ; ExpImag1DP, - ExpImag1DP
    movapd  xmm5, [rsi+16]          ; ExpImag2DP, - ExpImag2DP
    movapd  xmm6, [rsi+32]          ; ExpReal1DP,   ExpReal1DP
    movapd  xmm7, [rsi+48]          ; ExpReal2DP,   ExpReal2DP
    align 16
lp: movapd  xmm0, [rax+rbx]         ; cDataDP[j2+k+d2]   & [j2+k+d2+1]
    movapd  xmm1, [rax+rbx+16]      ; cDataDP[j2+k+d2+2] & [j2+k+d2+3]
    movapd  xmm2, xmm0              ; cDataDP[j2+k+d2]   & [j2+k+d2+1]
    movapd  xmm3, xmm1              ; cDataDP[j2+k+d2+2] & [j2+k+d2+3]
    mulpd   xmm0, xmm4              ; ExpImag1DP, - ExpImag1DP
    mulpd   xmm1, xmm5              ; ExpImag2DP, - ExpImag2DP
    shufpd  xmm0, xmm0, 1           ; reverse pair
    shufpd  xmm1, xmm1, 1           ; reverse pair
    mulpd   xmm2, xmm6              ; ExpReal1DP, ExpReal1DP
    mulpd   xmm3, xmm7              ; ExpReal2DP, ExpReal2DP
    addpd   xmm0, xmm2              ; tempReal1, tempImag1
    addpd   xmm1, xmm3              ; tempReal2, tempImag2
    movapd  xmm2, [rax]             ; cDataDP[j2+k]   & cDataDP[j2+k+1]
    movapd  xmm3, [rax+16]          ; cDataDP[j2+k+2] & cDataDP[j2+k+3]
    subpd   xmm2, xmm0              ; cDataDP[pair] - tempReal1, tempImag1
    subpd   xmm3, xmm1              ; cDataDP[pair] - tempReal2, tempImag2
    movapd  [rax+rbx],    xmm2      ; save cDataDP[j2+k+d2]   & [j2+k+d2+1]
    movapd  [rax+rbx+16], xmm3      ; save cDataDP[j2+k+d2+2] & [j2+k+d2+3]
    movapd  xmm2, [rax]             ; cDataDP[j2+k]   & cDataDP[j2+k+1]
    movapd  xmm3, [rax+16]          ; cDataDP[j2+k+2] & cDataDP[j2+k+3]
    addpd   xmm2, xmm0              ; cDataDP[pair] + tempReal1, tempImag1
    addpd   xmm3, xmm1              ; cDataDP[pair] + tempReal2, tempImag2
    movapd  [rax],    xmm2          ; save cDataDP[j2+k]   & [j2+k+1]
    movapd  [rax+16], xmm3          ; save cDataDP[j2+k+2] & [j2+kd+3]
    add     rax, rdx                ; address cDataDP[j2+k+d2]
    add     rcx, rdx                ; k=k+d2
    cmp     rcx, rdi                ; k vs b2
    jl      lp
    mov  eax, DWORD PTR xmmSave
    movapd  xmm6, OWORD PTR [eax]
    movapd  xmm7, OWORD PTR [eax+16]
    pop rsi
    pop rdi
    pop rdx
    pop rcx
    pop rbx
    pop rax
    ret
SSE2code2 ENDP


SSE2code4 PROC
    push rax
    push rbx
    push rcx
    push rdx
    push rdi
    push rsi   
        align 16
        mov  eax, DWORD PTR xmmSave
        movapd  OWORD PTR [eax], xmm6
        movapd  OWORD PTR [eax+16], xmm7
        mov     rbx, d2a
        mov     rcx, 0                  ; k
        mov     rdx, j2a
        add     rdx, rdx                ; j*2
        mov     rdi, na
        add     rdi, rdi                ; n*2
        mov     rsi, aDataDP            ; not lea
        add     rsi, rdx                ; address cDataDP[j2]
        mov     rdx, rbx                ; d2
        add     rdx, rdx                ; d2*2
        mov     rax, rsi                ; address cDataDP[j2]
        add     rax, rcx                ; address cDataDP[jk or j2 + k]
        mov     rsi, cExpDPA
        align 16
    lp:
        movapd  xmm0, [rax+rbx]         ; cDataDP[j2+k+d2]   & [j2+k+d2+1]
        movapd  xmm1, [rax+rbx+16]      ; cDataDP[j2+k+d2+2] & [j2+k+d2+3]
        movapd  xmm2, [rax+rbx+32]      ; cDataDP[j2+k+d2+4] & [j2+k+d2+5]
        movapd  xmm3, [rax+rbx+48]      ; cDataDP[j2+k+d2+6] & [j2+k+d2+7]
        mulpd   xmm0, [rsi]             ; ExpImag1DP, - ExpImag1DP
        mulpd   xmm1, [rsi+16]          ; ExpImag2DP, - ExpImag2DP
        mulpd   xmm2, [rsi+32]          ; ExpImag3DP, - ExpImag3DP
        mulpd   xmm3, [rsi+48]          ; ExpImag4DP, - ExpImag4DP
        shufpd  xmm0, xmm0, 1           ; reverse pair
        shufpd  xmm1, xmm1, 1           ; reverse pair
        shufpd  xmm2, xmm2, 1           ; reverse pair
        shufpd  xmm3, xmm3, 1           ; reverse pair
        movapd  xmm4, [rax+rbx]         ; cDataDP[j2+k+d2]   & [j2+k+d2+1]
        movapd  xmm5, [rax+rbx+16]      ; cDataDP[j2+k+d2+2] & [j2+k+d2+3]
        movapd  xmm6, [rax+rbx+32]      ; cDataDP[j2+k+d2+4] & [j2+k+d2+5]
        movapd  xmm7, [rax+rbx+48]      ; cDataDP[j2+k+d2+6] & [j2+k+d2+7]
        mulpd   xmm4, [rsi+64]          ; ExpReal1DP, ExpReal1DP
        mulpd   xmm5, [rsi+80]          ; ExpReal2DP, ExpReal2DP
        mulpd   xmm6, [rsi+96]          ; ExpReal3DP, ExpReal3DP
        mulpd   xmm7, [rsi+112]         ; ExpReal4DP, ExpReal4DP
        addpd   xmm0, xmm4              ; tempReal1, tempImag1
        addpd   xmm1, xmm5              ; tempReal2, tempImag2
        addpd   xmm2, xmm6              ; tempReal3, tempImag3
        addpd   xmm3, xmm7              ; tempReal4, tempImag4
        movapd  xmm4, [rax]             ; cDataDP[j2+k]   & cDataDP[j2+k+1]
        movapd  xmm5, [rax+16]          ; cDataDP[j2+k+2] & cDataDP[j2+k+3]
        movapd  xmm6, [rax+32]          ; cDataDP[j2+k+4] & cDataDP[j2+k+5]
        movapd  xmm7, [rax+48]          ; cDataDP[j2+k+6] & cDataDP[j2+k+7]
        subpd   xmm4, xmm0              ; cDataDP[pair] - tempReal1, tempImag1
        subpd   xmm5, xmm1              ; cDataDP[pair] - tempReal2, tempImag2
        subpd   xmm6, xmm2              ; cDataDP[pair] - tempReal3, tempImag3
        subpd   xmm7, xmm3              ; cDataDP[pair] - tempReal4, tempImag4
        movapd  [rax+rbx],    xmm4      ; save cDataDP[j2+k+d2]   & [j2+k+d2+1]
        movapd  [rax+rbx+16], xmm5      ; save cDataDP[j2+k+d2+2] & [j2+k+d2+3]
        movapd  [rax+rbx+32], xmm6      ; save cDataDP[j2+k+d2+4] & [j2+k+d2+5]
        movapd  [rax+rbx+48], xmm7      ; save cDataDP[j2+k+d2+6] & [j2+k+d2+7]
        movapd  xmm4, [rax]             ; cDataDP[j2+k]   & cDataDP[j2+k+1]
        movapd  xmm5, [rax+16]          ; cDataDP[j2+k+2] & cDataDP[j2+k+3]
        movapd  xmm6, [rax+32]          ; cDataDP[j2+k+4] & cDataDP[j2+k+5]
        movapd  xmm7, [rax+48]          ; cDataDP[j2+k+6] & cDataDP[j2+k+7]
        addpd   xmm4, xmm0              ; cDataDP[pair] + tempReal1, tempImag1
        addpd   xmm5, xmm1              ; cDataDP[pair] + tempReal2, tempImag2
        addpd   xmm6, xmm2              ; cDataDP[pair] + tempReal3, tempImag3
        addpd   xmm7, xmm3              ; cDataDP[pair] + tempReal4, tempImag4
        movapd  [rax],    xmm4          ; save cDataDP[j2+k]   & [j2+k+1]
        movapd  [rax+16], xmm5          ; save cDataDP[j2+k+2] & [j2+kd+3]
        movapd  [rax+32], xmm6          ; save cDataDP[j2+k+4] & [j2+k+5]
        movapd  [rax+48], xmm7          ; save cDataDP[j2+k+6] & [j2+k+7]
        add     rax, rdx                ; address cDataDP[j2+k+d2]
        add     rcx, rdx                ; k=k+d2
        cmp     rcx, rdi                ; k vs b2
        jl      lp
        mov  eax, DWORD PTR xmmSave
        movapd  xmm6, OWORD PTR [eax]
        movapd  xmm7, OWORD PTR [eax+16]
    pop rsi
    pop rdi
    pop rdx
    pop rcx
    pop rbx
    pop rax
    ret
SSE2code4 ENDP

END

