/* 
 *    64 Bit Integer Reliability Test March 2006
 *    Wrong sizes at 4 GB- Line 319 for (i=1; i<20; i++) was 19
 *    _aligned_malloc Line 862 needs __int64 - Version 1.1
 *   Version 1.2 Sept 07 Paging (P) parameter to run just one test 
 */
 
#define NAME "Test"
#define TITLE " 64 Bit Integer Burn-in Test"
#define INITGUID

#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <time.h>
#include <xmmintrin.h>
#include <malloc.h>
#include <math.h>
#include "IntBurn64.h"
#include "asmtime.h"

//  ************** PROTOPTYPES *****************

BOOL FAR PASCAL AboutDlgProc( HWND, UINT, WPARAM, LPARAM);
static BOOL InitApp(HINSTANCE, LPSTR, int);
LRESULT CALLBACK WindowProc(HWND, UINT, WPARAM, LPARAM);                  
static void CleanUpAndPostQuit(void);
void displayWhatever(HWND);

BOOL FAR PASCAL TestPanel( HWND, UINT, WPARAM, LPARAM);

void local_time();
void end_time();
void start_time();

BOOL setUp();
BOOL runTests1();
BOOL runTests2();
BOOL finish();

void checkData();


// ************* GLOBAL VARIABLES **********

__int64 *xx;
__int64 sumCheck[8];

__int64 mempasses;
__int64 outerLoop;
__int64 calcResult =  { 0x0000000000000000 }; 

__int64 usePattern1;
__int64 usePattern2;
__int64 isdata[16];
__int64 sbdata[16];
__int64 errword[16];
__int64 passbytes;
__int64 pattern1[16];
__int64 pattern2[16];
__int64 tempPattern;

char    timeday[30];
int     n1;
int     RrunSecs;
int     RtestTimes[20];
int     RtimeToDo;
int     RmaxToDo;
char    logfile[80] = "BurnLog.txt";
char    version[30] = "Version 1.2 for 64 bit OS";


BOOL bQuit = FALSE;

HWND   mainHWND;
HWND   testHwnd = NULL;
HINSTANCE MyInstance;
char    windowText[256];
char    commandLine[1024] = "";

short     keyPress;
BOOL  autoRun = FALSE;
BOOL  oneTest = FALSE;
BOOL  doTesting = FALSE;
char   writeMsg1[256];
char   writeMsg2[256];
char   writeMsg3[256];
char   writeMsg4[256];
double results[30][10];

int    memUsed[100];
int  passesDone;

BOOL  runDone = FALSE;
int  ramKBused;
int  ramKB;
int Rrun = 10; // 2 MB;
int runsInit = 10;
DWORD allocMemK[50];
RECT     winRect;
int     screenWide;
int     screenHigh;
char  testmsg[30][256];
DWORD  useMemK = 2048; // 2048;
int  i0Start;
int  errors;
int  errord;
int  errorp;
char errormsg[64] = " ";
int  xpos = 0;
int  ypos = 0;
BOOL multiWin = FALSE;
BOOL isCommand = FALSE;
int  phase = 0;
int  partp = 0;
double n1Count;
double timeCount;
double millionBytes;
char patternSB[20];
char patternIs[20];
char testmsgOld[256];
double endSecs0; 
double endSecs3;
double maxMIPS0;
double maxMIPS1;
double maxMIPS2;
int jval = -1;
BOOL running = FALSE;

FILE    *outfile;


void displayWhatever(HWND hwnd)
{
    sprintf(windowText, " Bus and Memory 64 Bit Reliability Tests");
    SetWindowText(mainHWND, windowText);        
        
    if (doTesting)
    {
        if (testHwnd)   DestroyWindow(testHwnd);
    }
    else
    {    
        testHwnd = CreateDialog( MyInstance,"DIALOG_8", hwnd, (DLGPROC)TestPanel);
    }  
} // displayWhatever


// WinMain - initialization, message loop

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     LPSTR cmdline, int cmdshow)
{
    MSG         msg;
    
    hPrevInstance = hPrevInstance;

    if (!InitApp(hInstance, cmdline, cmdshow))
         return FALSE;

    GetMessage( &msg, NULL, 0, 0 );

    if (autoRun)
    {
        doTesting = TRUE;
    }        
    while(!bQuit)
    {
        if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
        {
            
           if (msg.message == WM_QUIT)
           {
                CleanUpAndPostQuit();
                break;
           }
   
           if( !GetMessage( &msg, NULL, 0, 0 ) ) return (int)msg.wParam;
           TranslateMessage(&msg);
           DispatchMessage(&msg);
        }
        else if (phase == 1)
        {
            if (!setUp())
            {
                CleanUpAndPostQuit();
                phase = 0;
            }
            phase = 2;
            partp = 1;
        }
        else if (phase == 2)
        {
            if (!runTests1())
            {
                fflush(outfile);
                fclose(outfile);
                CleanUpAndPostQuit();
                phase = 0;
            }
            if (jval == 12)
            {
                jval = 0;
                phase = 3;
                partp = 1;
            }
        }
        else if (phase == 3)
        {
            if (!runTests2())
            {
                fflush(outfile);
                fclose(outfile);
                CleanUpAndPostQuit();
                phase = 0;
            }
            if (jval == 6)
            {
                jval = -1;
                phase = 4;
                partp = 0;
            }
        }
        else if (phase == 4)
        {
            runDone = TRUE;
            if (!finish())
            {
                CleanUpAndPostQuit();
                phase = 0;
            }
            phase = 0;
            if (autoRun) CleanUpAndPostQuit();
        }
        else
        {
           // make sure we go to sleep if we have nothing else to do
           WaitMessage();
        }
    }
    return (int)msg.wParam;
    
} // WinMain

// ***************************************************************************
//                    Initialization and object creation                     *
// ***************************************************************************

// InitApp
// Creates window

static BOOL
InitApp(HINSTANCE hInstance, LPSTR cmdline, int cmdshow)
{
    HWND hwnd;
    WNDCLASS wc;
    int   i, j;
    char *delims = {" ,"};
    char commands[20][256];
    char *p;
    DWORD  KBytes;
    DWORD  bytesK1;
    char buf[256] = "";
    HDC  hdc;
    int runSecs = 0;
    BOOL isHere;
    BOOL isBat;
    int newPos =0;
  
    
    // set up and registers the window class
    
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = sizeof(DWORD);
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(hInstance, "GenericIcon");
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName = "GenericMenu";
    wc.lpszClassName = NAME;
    if (!RegisterClass(&wc))
        return FALSE;

    // Create the window

    hwnd =
        CreateWindow(
            NAME,
            TITLE,
            WS_OVERLAPPEDWINDOW | WS_HSCROLL | WS_VSCROLL,
            0,
            0,
            640,
            480,
            NULL, 
            NULL, 
            hInstance, 
            NULL 
        );

    if (!hwnd) return FALSE;

    mainHWND = hwnd;
    strcpy(commandLine, strupr(cmdline));

    hdc = GetDC(mainHWND);
    screenWide = GetDeviceCaps(hdc, HORZRES);
    screenHigh = GetDeviceCaps(hdc, VERTRES);   
    ReleaseDC(mainHWND, hdc);

    GetClientRect(mainHWND, &winRect);

    getDetails();
    ramKB = ramsize * 1024;

    allocMemK[0] = 4;  
    for (i=1; i<21; i++)
    {
        allocMemK[i] = allocMemK[i-1] * 2;
    }

    if (ramKB >   14000) runsInit = 11;
    if (ramKB >   30000) runsInit = 12;
    if (ramKB >   60000) runsInit = 13;
    if (ramKB >  120000) runsInit = 14;
    if (ramKB >  250000) runsInit = 16;
    if (ramKB >  500000) runsInit = 17;
    if (ramKB > 1000000) runsInit = 18;
    if (ramKB > 2000000) runsInit = 19;
    if (ramKB > 4000000) runsInit = 20;
    Rrun  = runsInit;


    RtestTimes[0] = 1;
    RtestTimes[1] = 5;
    RtestTimes[2] = 10;
    RtestTimes[3] = 50;
    RtestTimes[4] = 100;
    RtestTimes[5] = 500;
    RtestTimes[6] = 1000;
    RtimeToDo = 1;
    RrunSecs = RtestTimes[RtimeToDo];
    RmaxToDo = 7;

    i = 0;
    p = strtok(commandLine, delims);
    while (p != NULL)
    {
        strcpy(commands[i], p);
        strcat(buf, commands[i]);
        strcat(buf, " ");
        i = i + 1;
        if (i > 9) break;
        p = strtok(NULL, delims);
    }
    if (i > 0)
    {
        strcpy(commandLine, buf);
        isCommand = TRUE;
    }
    else
    {
        strcpy(commandLine, "None");
    }
    autoRun = FALSE;
    isBat = FALSE;
    KBytes = 0;
       
    for (j=0; j<i; j++)
    {
        switch(commands[j][0])
        {            
            case 'A': // Auto Run
             autoRun = TRUE;
             isBat = TRUE;
             phase = 1;
             jval = 6;
             break;            

            case 'K': // KBytes
             if (j < i -1)
             {
                 sscanf(commands[j+1], "%d", &KBytes);
             }
             break;            
       

            case 'S': // seconds
             if (j < i -1)
             {
                 sscanf(commands[j+1], "%d", &runSecs);
             }
             break;        

            case 'L': // log file
             if (j < i -1)
             {
                 sscanf(commands[j+1], "%s", logfile);
             }
             break;
        }            
    }

    for (j=0; j<i; j++)
    {
        if (strnicmp(commands[j],  "PA", 2) == 0)
        {
            oneTest = TRUE; // One Test Only For Paging
        }
        if (strnicmp(commands[j],  "P1", 2) == 0)
        {
            xpos = 0;
            ypos = 0;
            multiWin = TRUE;
        }
        if (strnicmp(commands[j],  "P2", 2) == 0)
        {
            xpos = 0;
            ypos = screenHigh - 500;
            if (ypos < 0) ypos = 0;
            multiWin = TRUE;
        }
        if (strnicmp(commands[j],  "P3", 2) == 0)
        {
            xpos = screenWide - 660;
            if (xpos < 0) xpos = 0;
            ypos = 0;
            multiWin = TRUE;
        }
        if (strnicmp(commands[j],  "P4", 2) == 0)
        {
            xpos = screenWide - 660;
            if (xpos < 0) xpos = 0;
            ypos = screenHigh - 500;
            if (ypos < 0) ypos = 0;
            multiWin = TRUE;
        }
    }
    if (KBytes > 0)
    {
        bytesK1 = KBytes;
        isHere = FALSE;
        isBat = TRUE;
        for (i=0; i<runsInit; i++)
        {
            if (bytesK1 == allocMemK[i])
            {
                isHere = TRUE;
                newPos = i;
            }            
        }    
        if (!isHere)
        {
            newPos = 0;
            for (i=0; i<runsInit; i++)
            {
                if (bytesK1 > allocMemK[i]) newPos = i + 1;
            }
            if (newPos != runsInit)
            {
                for (i=runsInit; i>newPos; i--)
                {
                    allocMemK[i] = allocMemK[i-1];
                }
            }
            allocMemK[newPos] = bytesK1;    
            runsInit = runsInit + 1;
        }
        Rrun = newPos+1;
    }
    ramKBused = allocMemK[Rrun-1];    
    useMemK = ramKBused;
    if (!isBat)
    {
        if (runsInit == 13)
        {
            allocMemK[runsInit] = allocMemK[runsInit-1] * 3/2;
            runsInit = runsInit + 1;
        }
        else if (runsInit == 14)
        {
            allocMemK[runsInit] = allocMemK[runsInit-1] * 2;
            runsInit = runsInit + 1;
        }
        else if (runsInit > 15)
        {
            allocMemK[runsInit] = allocMemK[runsInit-1] * 3/2;
            runsInit = runsInit + 1;
            if (runsInit > 17)
            {
                allocMemK[runsInit] = (ramKB / 128000 * 131072 - 65536);
                runsInit = runsInit + 1;
            }
        }
    }


    if (runSecs > 0) RrunSecs = runSecs; 

    isHere = FALSE;
    for (i=0; i<RmaxToDo; i++)
    {
        if (RrunSecs == RtestTimes[i])
        {
            isHere = TRUE;
            newPos = i;
        }            
    }
    if (!isHere)
    {
        newPos = 0;
        for (i=0; i<RmaxToDo; i++)
        {
            if (RrunSecs > RtestTimes[i]) newPos = i + 1;
        }            
        if (newPos != RmaxToDo)
        {
            for (i=RmaxToDo; i>newPos; i--)
            {
                 RtestTimes[i] =  RtestTimes[i-1];
            }
        }
        RtestTimes[newPos] = RrunSecs;
        RmaxToDo = RmaxToDo + 1;
    }
    RtimeToDo = newPos;
    
    
    keyPress = GetAsyncKeyState(VK_ESCAPE);

    // Display the window
    
    MoveWindow(mainHWND, xpos, ypos, 640, 480, FALSE);

    ShowWindow(hwnd, cmdshow);    
    UpdateWindow(hwnd);

    if (!autoRun) displayWhatever(mainHWND);
    
    return TRUE;
    
}  // InitApp



// WindowProc - handle messages for the main application window


LRESULT CALLBACK WindowProc(HWND hwnd, UINT msg,
                            WPARAM wparam, LPARAM lparam)                  
{
           
    switch( msg )
    {
    case WM_ACTIVATEAPP:
        break;
        
    case WM_INITMENUPOPUP:
        break;
        
    case WM_CREATE:
        break;

    case WM_DESTROY:
        CleanUpAndPostQuit();
        break;

    case WM_COMMAND:
        switch( LOWORD( wparam ) )
        {
        case MENU_ABOUT:
            if (testHwnd)   DestroyWindow(testHwnd);
            DialogBox( MyInstance,"AboutBox", hwnd, (DLGPROC)AboutDlgProc );
            displayWhatever(mainHWND);                                      
            break;

        case MENU_RHELP:
            if (testHwnd)   DestroyWindow(testHwnd);
            DialogBox( MyInstance,"RelHelp", hwnd, (DLGPROC)AboutDlgProc );
            displayWhatever(mainHWND);                                      
            break;

        case MENU_BHELP:
            if (testHwnd)   DestroyWindow(testHwnd);
            DialogBox( MyInstance,"BatchHelp", hwnd, (DLGPROC)AboutDlgProc );
            displayWhatever(mainHWND);                                      
            break;
            
       case MENU_TEST:
            doTesting = TRUE;
            displayWhatever(mainHWND);                                      
            phase = 1;
            jval = 6;
            break;

        case MENU_DISPLAY:
            displayWhatever(mainHWND);                                      
            break;
        
        case MENU_EXIT:
            CleanUpAndPostQuit();
            break;
                
        }
        break;
   
        case WM_PAINT:
             break;
           
        case WM_KEYDOWN:
            break;

       case WM_ACTIVATE:
            break;
    } 
    return DefWindowProc( hwnd, msg, wparam, lparam );

} // WindowProc




// AboutDlgProc - processes messages for the about dialog.

BOOL FAR PASCAL AboutDlgProc( HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam )
{
    lparam = lparam;

    switch( msg ) {
    case WM_INITDIALOG:
        return( TRUE );

    case WM_COMMAND:
        if( LOWORD( wparam ) == IDOK ) {
            EndDialog( hwnd, TRUE );
            return( TRUE );
        }
        break;
    }
    return( FALSE );

} // AboutDlgProc



  
void local_time()
{
    time_t time_of_day;
    time_of_day = time( NULL ); 
    strcpy (timeday, ctime(&time_of_day)); // timeday = date and time
    return;
}




// CleanUpAndPostQuit
// Release all D3DRM objects, post a quit message and set the bQuit flag

void
CleanUpAndPostQuit(void)
{
    bQuit = TRUE;
    return;
}



BOOL FAR PASCAL TestPanel( HWND hdlg, UINT msg,
                                WPARAM wparam, LPARAM lparam )
{
    wparam = wparam;
    lparam = lparam;
    hdlg = hdlg;
    int  k, index;
    int FAR  tabs[11] = {1, 33, 60, 87, 114, 141, 168, 195, 222, 249, 276};

     switch( msg )
     {
       case WM_INITDIALOG:
        SendDlgItemMessage(hdlg, RESULTS, LB_SETTABSTOPS, (WPARAM) 11, (LPARAM) (int FAR*) tabs);
        for (k=0; k<runsInit; k++)
        {
            sprintf(writeMsg1, "%8d",  allocMemK[k]);
            SendDlgItemMessage(hdlg, AT_KB, CB_ADDSTRING, 0, (LPARAM) writeMsg1);
        }
        SendDlgItemMessage(hdlg, AT_KB, CB_SETCURSEL, Rrun-1, 0L);

        for (k=0; k<RmaxToDo; k++)
        {
            sprintf(writeMsg1, "%8d",  RtestTimes[k]);
            SendDlgItemMessage(hdlg, AT_SECS, CB_ADDSTRING, 0, (LPARAM) writeMsg1);
        }
        SendDlgItemMessage(hdlg, AT_SECS, CB_SETCURSEL, RtimeToDo, 0L);
        
        SendDlgItemMessage(hdlg, RESULTS, LB_SETHORIZONTALEXTENT, 700, 0L);
        if (runDone)
        {
            for (k=6; k<12; k++)
            {
               sprintf(writeMsg1, "Wr %6d KB %6.0f MB/Sec %s", memUsed[0], results[k][0], testmsg[k]);
               SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg1);
            }
            for (k=0; k<passesDone; k++)
            {
               sprintf(writeMsg1, "Rd %6d KB %6.0f MB/Sec %s", memUsed[0], results[k][0], testmsg[k]);
               SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg1);                   
            }
            SendDlgItemMessage(hdlg, RESULTS, LB_SETCURSEL, 20, 0L);

            if (strlen(errormsg) > 10)
            {               
                sprintf(writeMsg1, " ERRORS in test. See %s log file", logfile);
            }
            else
            {
                sprintf(writeMsg1, " ");
                SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg1);
                sprintf(writeMsg1, " Reliability Test Using 64 bit Instructions ");
            }
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg1);
            sprintf(writeMsg1, " Memory size %7d KB, %d seconds per test", useMemK, RrunSecs);
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg1);
            sprintf(writeMsg1, " Results should be in file %s", logfile);
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg1);
        }
        else
        {
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) configdata[1]);
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) configdata[2]);
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) configdata[7]);
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) " ");
            strcpy(writeMsg1, " Batch Command ");
            strncat(writeMsg1, commandLine, 200);
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg1);
            sprintf(writeMsg1, " ");
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg1);
            if (isCommand)
            {
                sprintf(writeMsg1, " Memory size %7d KB, %d seconds per test", useMemK, RrunSecs);
                SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg1);
            }
            else
            {
                sprintf(writeMsg1, " RELIABILITY - Select memory size to test and run time then Run Tests button");
                SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg1);
                sprintf(writeMsg1, " Initial memory size %7d KB, %d seconds per test", useMemK, RrunSecs);
                SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg1);
            }
            sprintf(writeMsg1, " ");
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg1);
            sprintf(writeMsg1, " After running, results should be in file %s", logfile);
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg1);
        }
        return( TRUE );
                    
        case WM_COMMAND:

        if( HIWORD( wparam ) == CBN_SELCHANGE)
        {
            switch (LOWORD (wparam))
            {              
                case AT_KB:
                 index = (int)SendDlgItemMessage(hdlg, AT_KB, CB_GETCURSEL, 0, 0);
                 useMemK = allocMemK[index];
                 Rrun = index + 1;
                 isCommand = TRUE;
                 if (testHwnd)   DestroyWindow(testHwnd);
                 testHwnd = CreateDialog( MyInstance,"DIALOG_8", mainHWND, (DLGPROC)TestPanel);
                 break;                

                case AT_SECS:
                 index = (int)SendDlgItemMessage(hdlg, AT_SECS, CB_GETCURSEL, 0, 0);
                 RtimeToDo = index;
                 RrunSecs = RtestTimes[RtimeToDo];
                 isCommand = TRUE;
                 if (testHwnd)   DestroyWindow(testHwnd);
                 testHwnd = CreateDialog( MyInstance,"DIALOG_8", mainHWND, (DLGPROC)TestPanel);
                 break;                
            }
            
        }
        else if( HIWORD( wparam ) == BN_CLICKED)
        {
            switch (LOWORD (wparam))
            {
                case TEST_IT:
                  PostMessage(mainHWND, WM_COMMAND, MENU_TEST, 0);
                 break;
                 

                case EXIT_BUTTON:
                 PostMessage(mainHWND, WM_COMMAND, MENU_EXIT, 0);
                 break;
            }
        }
        return( TRUE );         
     }
     return( FALSE );
    
} // TestPanel



BOOL setUp()
{
    HDC hdc;

    pattern1[0]  = 0x0000000000000000;
    pattern1[1]  = 0xFFFFFFFFFFFFFFFF;
    pattern1[2]  = 0xA5A5A5A5A5A5A5A5;
    pattern1[3]  = 0x5555555555555555;
    pattern1[4]  = 0x3333333333333333;
    pattern1[5]  = 0xF0F0F0F0F0F0F0F0;
    pattern1[6]  = 0x0000000000000000;
    pattern1[7]  = 0xFFFFFFFFFFFFFFFF;
    pattern1[8]  = 0xA5A5A5A5A5A5A5A5;
    pattern1[9]  = 0x5555555555555555;
    pattern1[10] = 0x3333333333333333;
    pattern1[11] = 0xF0F0F0F0F0F0F0F0;

    pattern2[0]  = 0x0000000000000000;
    pattern2[1]  = 0xFFFFFFFFFFFFFFFF;
    pattern2[2]  = 0x5A5A5A5A5A5A5A5A;
    pattern2[3]  = 0xAAAAAAAAAAAAAAAA;
    pattern2[4]  = 0xCCCCCCCCCCCCCCCC;
    pattern2[5]  = 0x0F0F0F0F0F0F0F0F;
    pattern2[6]  = 0xFFFFFFFFFFFFFFFF;
    pattern2[7]  = 0x0000000000000000;
    pattern2[8]  = 0x5A5A5A5A5A5A5A5A;
    pattern2[9]  = 0xAAAAAAAAAAAAAAAA;
    pattern2[10] = 0xCCCCCCCCCCCCCCCC;
    pattern2[11] = 0x0F0F0F0F0F0F0F0F;

    outfile = fopen(logfile,"a+");
    if (outfile == NULL)
    {
        sprintf(writeMsg1, "Cannot open results file");
        if (!autoRun) MessageBox(NULL, writeMsg1, "ERROR WILL EXIT", MB_ICONWARNING | MB_OK);
        CleanUpAndPostQuit();
        return FALSE;
    }

    local_time();

    fprintf(outfile, "\n #########################################################################\n");
    fprintf(outfile, "           64 Bit Integer Reliability Test %s\n\n", version);
    fprintf(outfile, "                   Copyright (C) Roy Longbottom 2007\n\n");
    strcpy(writeMsg2, " Batch Command ");
    strncat(writeMsg2, commandLine, 200);
    fprintf(outfile, " %s\n\n", writeMsg2);
    sprintf(writeMsg1, " Test %d KB at %d seconds per test", useMemK, RrunSecs);
    fprintf(outfile, " %s, Start at %s\n", writeMsg1, timeday);
    fflush(outfile);

    hdc = GetDC(mainHWND);
    sprintf(writeMsg1, "                          Allocating Memory  ");
    TextOut(hdc, 100, 100, writeMsg1, lstrlen(writeMsg1));
    ReleaseDC(mainHWND, hdc);

    GdiFlush();    
    sprintf(errormsg, " ");
    xx = (__int64 *)_aligned_malloc((__int64)useMemK*1024+256, 16);
    if (xx == NULL)
    {
        sprintf(writeMsg1, "Cannot allocate %d KB memory", useMemK);
        MessageBox(NULL, writeMsg1, "ERROR WILL EXIT", MB_ICONWARNING | MB_OK);
        fprintf(outfile," %s\n\n", writeMsg1);
        fflush(outfile);
        fclose(outfile);
        CleanUpAndPostQuit();
        return FALSE;
    }
    runDone = TRUE;    
    passesDone = 0;
    sprintf(testmsgOld, " ");

    errorp = 0;
    i0Start = 0;
    if (oneTest)
    {
        fprintf(outfile, "  Write/Read ");
    }
    else
    {
        fprintf(outfile, "  Write/Read\n");
    }
    fflush(outfile);
    maxMIPS2 = 0;
    maxMIPS1 = 0;
    return TRUE;

}  // setUp

BOOL runTests1()
{
    int i, j;
    HDC hdc;
    
    j = jval; // for (j=6; j<12; j++)
    if (oneTest) j = 9;
    if (partp == 1)
    {
        usePattern1 = pattern2[j];   
        usePattern2 = pattern1[j];   

        memUsed[0] = useMemK;
        millionBytes = (double) useMemK * 1.024 / 1000;

        mempasses = useMemK * 8; // 1024 / 128;

        hdc = GetDC(mainHWND);
        sprintf(writeMsg2, " Test %d of 12", jval - 5);                
        if (multiWin)
        {
            TextOut(hdc, 10, 10, writeMsg2, lstrlen(writeMsg2));
        }
        sprintf(writeMsg3, " Write Reliability Test Using 64 bit Instructions");                
        TextOut(hdc, 120, 50, writeMsg3, lstrlen(writeMsg3));
        if (oneTest)
        {
           sprintf(writeMsg4, "  One Test Only, Testing %7.1f MB, Pattern  %16.16I64X              ",
                                 millionBytes, usePattern2);
        }
        else
        {
           sprintf(writeMsg4, "  Test %2d of 6, Testing %d KB, Pattern  %16.16I64X, %d Seconds    ",
                             j-5, useMemK, usePattern1, RrunSecs);
        }                   
        TextOut(hdc, 80, 100, writeMsg4, lstrlen(writeMsg4));
        TextOut(hdc, 10, 200, testmsgOld, lstrlen(testmsgOld));
        TextOut(hdc, 120, 300, errormsg, lstrlen(errormsg));
        ReleaseDC(mainHWND, hdc);

        GdiFlush();
        results[j][0] = 0;

        running = TRUE;
        n1Count = 0;
        timeCount = 0;
        partp = 2;
    }
    else if (partp == 2)
    {
        n1 = 0;
        start_time();
        do
        {
            tempPattern = usePattern1;
            usePattern1 = usePattern2;
            usePattern2 = tempPattern;
            xx[0]   = usePattern1;
            xx[1]   = usePattern1;
            xx[2]   = usePattern1;
            xx[3]   = usePattern1;
            xx[4]   = usePattern2;
            xx[5]   = usePattern2;
            xx[6]   = usePattern2;
            xx[7]   = usePattern2;
            writeData();
            checkData();
            n1 = n1 + 1;
            end_time();
        }
        while (secs < 1.0 && errors == 0);
        n1Count = n1Count + (double)n1;
        timeCount = timeCount + secs;
        sprintf(writeMsg1, "  Running %6.1f Seconds, %6.0f MB/Second                 ",
                    timeCount, (millionBytes * 2 * (double)n1 / secs));

        hdc = GetDC(mainHWND);
        TextOut(hdc, 130, 150, writeMsg1, lstrlen(writeMsg1));
        sprintf(writeMsg1, "  Press ESC to exit program");
        TextOut(hdc, 160, 250, writeMsg1, lstrlen(writeMsg1));
        if (multiWin)
        {
            TextOut(hdc, 10, 10, writeMsg2, lstrlen(writeMsg2));
        }
        TextOut(hdc, 120, 50, writeMsg3, lstrlen(writeMsg3));
        TextOut(hdc, 80, 100, writeMsg4, lstrlen(writeMsg4));
        TextOut(hdc, 10, 200, testmsgOld, lstrlen(testmsgOld));
        TextOut(hdc, 120, 300, errormsg, lstrlen(errormsg));
        ReleaseDC(mainHWND, hdc);
        GdiFlush();

        if (GetAsyncKeyState(VK_ESCAPE) != keyPress)
        {
            fprintf(outfile, "\nESCAPE Pressed\n\n");
            _aligned_free(xx);
            fflush(outfile);
            fclose(outfile);
            CleanUpAndPostQuit();
            return FALSE;
        }
        if (timeCount >= (double)RrunSecs || errors > 0)
        {
            partp = 3;
        }
    }
    else if (partp == 3)
    { 
        running = FALSE;
        results[j][0] = millionBytes * 2 * n1Count / timeCount;
        maxMIPS0 = n1Count * 54 * (double)mempasses / 1000000 / timeCount;
        if (maxMIPS0 > maxMIPS1) maxMIPS1 = maxMIPS0;
        
        sprintf(patternSB, "%16.16I64X", usePattern1);
        if (errors == 0)
        {
             sprintf(testmsg[j], " Pattern %s %c Result OK %9.0f passes", patternSB, 9, n1Count);
        }
        else
        {
            sprintf(testmsg[j], " Pattern %s %c ERROR            ", patternSB);
        }
        sprintf(testmsgOld, " Last test %s %6.0f MB/sec                              ",
                                testmsg[j], results[j][0]);
        if (oneTest)
        {
            fprintf(outfile, " %7.1f Seconds %7.1f MB x %d passes x 2 (M = 1,000,000)\n", timeCount, millionBytes, (int)n1Count);
            fprintf(outfile, " %7.0f MB/sec %s\n", results[j][0], testmsg[j]);
        }
        else
        {
            fprintf(outfile, " %2d %7.0f MB/sec %s\n", j-5, results[j][0], testmsg[j]);
        }
        if (errors > 0)
        {
            fprintf(outfile, " %dK 4 byte words checked and %d errors found\n", useMemK/4, errors);
            if (errors < 12)
            {
                fprintf(outfile, " %d errors\n", errord);
            }
            else
            {
                fprintf(outfile, " First 12 errors\n");
            } 
            for (i=0; i<errord; i++)
            {
                fprintf(outfile, " Pattern %16.16I64X Was %16.16I64X Word %d\n", sbdata[i], isdata[i], errword[i]);
            }
            sprintf(errormsg, "      ERRORS - See %s logfile ", logfile);
        }
        fflush(outfile);
        jval = jval + 1;
        partp = 1;
        if (oneTest)
        {
            phase = 4;
            jval = 22;
        }
    }
    if (jval == 12)
    {
        fprintf(outfile, " Max %6.0f 64 bit MIPS\n", maxMIPS1);
        endSecs3 = 9999999;
        endSecs0 = 9999999;
        passesDone = 0;
        fprintf(outfile, " Read\n");
        fflush(outfile);
    }
    return TRUE;

}  // runTests1

BOOL runTests2()
{
    int i, j;
    HDC hdc;

    
    j = jval; // for (j=0; j<6; j++)
    if (partp == 1)
    {
        usePattern1 = pattern1[j];   
        usePattern2 = pattern2[j];   
        
        memUsed[0] = useMemK;
        millionBytes = (double) useMemK * 1.024 / 1000;

        sprintf(writeMsg1, "                             Loading Pattern           "
                          "                                                       ");
        hdc = GetDC(mainHWND);
        TextOut(hdc, 80, 100, writeMsg1, lstrlen(writeMsg1));
        ReleaseDC(mainHWND, hdc);
        GdiFlush();

        start_time();

        xx[0]   = usePattern1;
        xx[1]   = usePattern1;
        xx[2]   = usePattern1;
        xx[3]   = usePattern1;
        xx[4]   = usePattern2;
        xx[5]   = usePattern2;
        xx[6]   = usePattern2;
        xx[7]   = usePattern2;

        mempasses = useMemK * 8; // 1024 / 128;
        writeData();
        checkData();

        end_time();
        if (secs < endSecs3) endSecs3 = secs;

        if (errors > 0)
        {
            fprintf(outfile, "    ERROR found checking data after generation - Test %d\n", j+1);
            fprintf(outfile, " %dK 4 byte words checked and %d errors found\n", useMemK/4, errors);
            if (errors < 12)
            {
                fprintf(outfile, " %d errors\n", errord);
            }
            else
            {
                fprintf(outfile, " First 12 errors\n");
            } 
            for (i=0; i<errord; i++)
            {
                fprintf(outfile, " Pattern %16.16I64X Was %16.16I64X Word %d\n", sbdata[i], isdata[i], errword[i]);
            }
            sprintf(errormsg, "      ERRORS - See %s logfile ", logfile);
            fflush(outfile);
        }
        

        hdc = GetDC(mainHWND);
        sprintf(writeMsg2, " Test %d of 12", jval + 6);                
        if (multiWin)
        {
            TextOut(hdc, 10, 10, writeMsg2, lstrlen(writeMsg2));
        }
        sprintf(writeMsg3, " Read Reliability Test Using 64 bit Instructions");                
        TextOut(hdc, 120, 50, writeMsg3, lstrlen(writeMsg3));

        sprintf(writeMsg4, "  Test %2d of 6, Testing %d KB, Pattern  %16.16I64X, %d Seconds     ",
                             j+1, useMemK, usePattern1, RrunSecs);                   
        TextOut(hdc, 80, 100, writeMsg4, lstrlen(writeMsg4));
        TextOut(hdc, 10, 200, testmsgOld, lstrlen(testmsgOld));
        TextOut(hdc, 120, 300, errormsg, lstrlen(errormsg));
        ReleaseDC(mainHWND, hdc);
        GdiFlush();


        results[j][0] = 0;

        passbytes = 128;
        mempasses = useMemK * 1024 / passbytes;

        outerLoop = 1;
        start_time();
        readData();
        end_time();
        outerLoop = 100;
        if (secs > 0.001) outerLoop = (__int64)(0.1/secs);
        if (outerLoop < 1) outerLoop = 1;

        running = TRUE;
        n1Count = 0;
        timeCount = 0;
        partp = 2;
    }
    else if (partp == 2)
    {
        n1 = 0;
        start_time();
        do
        {
            readData();
            n1 = n1 + 1;
            end_time();
        }
        while (secs < 1.0);
        n1Count = n1Count + (double)n1;
        timeCount = timeCount + secs;
        sprintf(writeMsg1, "  Running %6.1f Seconds, %6.0f MB/Second                 ",
                    timeCount, (millionBytes * (double)outerLoop * (double)n1 / secs));

        hdc = GetDC(mainHWND);
        TextOut(hdc, 130, 150, writeMsg1, lstrlen(writeMsg1));
        sprintf(writeMsg1, "  Press ESC to exit program");
        TextOut(hdc, 160, 250, writeMsg1, lstrlen(writeMsg1));
        if (multiWin)
        {
            TextOut(hdc, 10, 10, writeMsg2, lstrlen(writeMsg2));
        }
        TextOut(hdc, 120, 50, writeMsg3, lstrlen(writeMsg3));
        TextOut(hdc, 80, 100, writeMsg4, lstrlen(writeMsg4));
        TextOut(hdc, 10, 200, testmsgOld, lstrlen(testmsgOld));
        TextOut(hdc, 120, 300, errormsg, lstrlen(errormsg));        ReleaseDC(mainHWND, hdc);
        GdiFlush();

        if (GetAsyncKeyState(VK_ESCAPE) != keyPress)
        {
            fprintf(outfile, "\nESCAPE Pressed\n\n");
            _aligned_free(xx);
            fflush(outfile);
            fclose(outfile);
            CleanUpAndPostQuit();
            return FALSE;
        }
        if (timeCount >= (double)RrunSecs)
        {
            partp = 3;
        }
    }
    else if (partp == 3)
    {
        running = FALSE;
        results[j][0] = millionBytes * (double)outerLoop * n1Count / timeCount;
        maxMIPS0 = n1Count * 19 * (double)mempasses * (double)outerLoop / 1000000 / timeCount;
        if (maxMIPS0 > maxMIPS2) maxMIPS2 = maxMIPS0;

        sprintf(patternSB, "%16.16I64X", usePattern1);
        sprintf(patternIs, "%16.16I64X",   calcResult);
        sprintf(testmsg[j], " Pattern %s %c Result OK %9.0f passes", patternSB, 9, n1Count * (double)outerLoop);
        if (strcmp(patternSB, patternIs) != 0)
        {
            sprintf(testmsg[j], " Pattern %s %c ERROR Was %s", patternSB, 9, patternIs);
            errorp = 1;
        }
        sprintf(testmsgOld, " Last test %s %6.0f MB/sec                              ",
                                testmsg[j], results[j][0]);
        fprintf(outfile, " %2d %7.0f MB/sec %s\n", j+1, results[j][0], testmsg[j]);
        fflush(outfile);
        
        i0Start = 2;
        start_time();
        checkData();
        end_time();
        if (secs < endSecs0) endSecs0 = secs;
        if (errors == 0)
        {
            if (errorp > 0)
            {
                fprintf(outfile, " %dK 4 byte words checked but no errors found\n", useMemK/4);
            }
        }
        else
        {
            if (errorp == 0)
            {
                fprintf(outfile, " No Errors in Reliability/Speed Test FAILED ON END COMPARE\n");
            }
            fprintf(outfile, " %dK 4 byte words checked and %d errors found\n", useMemK/4, errors);
            if (errors < 12)
            {
                fprintf(outfile, " %d errors\n", errord);
            }
            else
            {
                fprintf(outfile, " First 12 errors\n");
            } 
            for (i=0; i<errord; i++)
            {
                fprintf(outfile, " Pattern %16.16I64X Was %16.16I64X Word %d\n", sbdata[i], isdata[i], errword[i]);
            }
        }
        fflush(outfile);
        if (errors > 0)
        {
            sprintf(errormsg, "      ERRORS - See %s logfile ", logfile);
        }
        passesDone = j + 1;
        jval = jval + 1;
        partp = 1;
    }
    return TRUE;

} // runTests2

BOOL finish()
{
    int i;
    HDC hdc;
    if (!oneTest)
    {
        fprintf(outfile, " Max %6.0f 64 bit MIPS\n", maxMIPS2);
        fprintf(outfile, "\n");
        fprintf(outfile, " Minimum seconds - generate/check data %11.7f, compare %11.7f\n", endSecs3, endSecs0);
    }
    fprintf(outfile, "\n");
    local_time();
    fprintf(outfile, "             Reliability Test Ended %s", timeday);
    fprintf(outfile, "\n");
    for (i=0; i<9; i++)
    {
        fprintf(outfile, "%s\n", configdata[i]);
    }
    fprintf(outfile, "\n");
    fflush(outfile);
    fclose(outfile);
    _aligned_free(xx);
    doTesting = FALSE;
    if (!autoRun) displayWhatever(mainHWND);

    hdc = GetDC(mainHWND);
    Rectangle(hdc, winRect.left, winRect.top,
                   winRect.right, winRect.bottom);
    ReleaseDC(mainHWND, hdc);

    return TRUE;    

} // finish


void checkData()
{
    int i;
    DWORD m;

    sumCheck[0] = usePattern1;
    sumCheck[1] = usePattern2;

    mempasses = useMemK * 8; // 1024 / 128;            
    errorcheck();
    
    errors = 0;
    errord = 0;

    if (sumCheck[0] != usePattern1 ||
        sumCheck[1] != usePattern1 || 
        sumCheck[2] != usePattern2 ||
        sumCheck[3] != usePattern2 ||  errorp == 1)
    {
        for (m=0; m<useMemK*128; m=m+8)
        {
           if (sumCheck[0] != usePattern1 ||
               sumCheck[1] != usePattern1 || errorp == 1)
           {    
               for (i=i0Start; i<4; i++)
               {
                  if (xx[m+i] != usePattern1)
                  {
                      errors = errors + 1;
                      if (errors < 13)
                      {
                          isdata[errord] = xx[m+i];
                          sbdata[errord] = usePattern1;
                          errword[errord] = m+i;
                          errord = errord + 1;
                      }
                  }
               }
           }
           i0Start = 0;
           if (sumCheck[3] != usePattern2 ||
               sumCheck[4] != usePattern2 || errorp == 1) 
           {
               for (i=0; i<4; i++)
               {
                  if (xx[m+i+4] != usePattern2)
                  {
                      errors = errors + 1;
                      if (errors < 13)
                      {
                          isdata[errord] = xx[m+i+4];
                          sbdata[errord] = usePattern2;
                          errword[errord] = m+i+4;
                          errord = errord + 1;
                      }
                  }
               }
           }
        }
    }    
}


